/*                 Ajit K. Dabade
                     CPS615 Fall 1998   
                      Assignment # 4          */
                      
/*  The maximum number of processors used to run this program 
                      should be four.                              */


#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>

int fun(int a, int b);

main(int argc, char* argv[])
{ 
   int            N = 4;
   int            n;
   int            k;
   int            value;
   int            p;
   int            sum;
   int            final_sum = 0;
   int            gross_sum = 0;
   int            local_sum = 0;
 
   MPI_Datatype   new_mpi_t;  
   MPI_Status     status;
   MPI_Comm       comm;

   int             my_rank;
   int             q;
   
   int             x[4];
   int             y[4];
   int             array[4];
   int             i,j;  

   array[0] = array[1] = array[2] = array[3] = 0;
  
   MPI_Init(&argc, &argv);

   MPI_Comm_size(MPI_COMM_WORLD, &p);

   MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);

   n = N/p;

   for(i=0; i<n; i++)
   x[i] = i + 1;
   
   for(j=0; j<n; j++)
   y[j] = j + 1;

   for (k=0; k<p; k++)
   { 
      sum = 0;
      for (j=0; j<n; j++)
      {
         local_sum = 0;  
         for (i=0; i<n; i++)
         {   
            array[i] = fun(x[i], y[j]);
            local_sum = local_sum + array[i]; 
         }
         gross_sum += local_sum;
     }

  }  

   printf("I am Process #     -----> %d\n", my_rank);
   printf("My Calculated Sum  -----> %d\n", gross_sum);

   MPI_Sendrecv(&y, n, MPI_DOUBLE, (my_rank+1+p)%p,1, &array, n, MPI_DOUBLE, (my_rank-1+p)%p, 1, MPI_COMM_WORLD, &status);  

   for(i = 0; i <n/p; i++)
   y[i] = array[i];  

   MPI_Reduce(&gross_sum, &final_sum, 1, MPI_DOUBLE, MPI_SUM, 0, MPI_COMM_WORLD);

     if(my_rank == 0)
     {  
        printf("\nThe Final Value OF Function ----> %d \n\n", final_sum); 
     }    
    
  MPI_Finalize();

}            /*  End of main function   */ 
  
  
int fun(int a, int b)
{  
   int value;
   value = a*a + b*b;
   return value;

}          /*  End of fun function   */ 

